//+------------------------------------------------------------------+
//|                                                     nema nrp.mq4 |
//|                                                           mladen | 
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  Red
#property indicator_color5  LimeGreen
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    NemaPeriod      = 14;
extern int    NemaPrice       = PRICE_CLOSE;
extern int    NemaDepth       = 3;
extern bool   Interpolate     = true;
extern bool   ShowArrows      = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double nema[];
double nemaDa[];
double nemaDb[];
double upArrow[];
double dnArrow[];
double slope[];
double work[][50];
double coeff[50];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,nema);
   SetIndexBuffer(1,nemaDa);
   SetIndexBuffer(2,nemaDb);
   SetIndexBuffer(3,dnArrow);
   SetIndexBuffer(4,upArrow);
   SetIndexBuffer(5,slope);
   if (ShowArrows)
   {
     SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,242);
     SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,241);
   }
   else
   {
     SetIndexStyle(3,DRAW_NONE);
     SetIndexStyle(4,DRAW_NONE);
   }       
      NemaDepth = MathMax(MathMin(NemaDepth,49),1);
      for(int k=0; k<=NemaDepth; k++)
            coeff[k] = factorial(NemaDepth)/(factorial(NemaDepth-k)*factorial(k));
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   return(0); 
}
int deinit(){ return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,n,r,limit, counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { nema[0] = limit+1; return(0); }
         
   //
   //
   //
   //
   //
    
   if (calculateValue || timeFrame == Period())
   {
      double alpha = 2.0 / (1.0+NemaPeriod);
      
      //
      //
      //
      //
      //
      
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         if (!calculateValue && slope[limit]==-1) CleanPoint(limit,nemaDa,nemaDb);

         //
         //
         //
         //
         //
         
         for(i=limit, r=Bars-i-1; i>=0; i--,r++)
         {
            nema[i] = 0;
            double price = iMA(NULL,0,1,0,MODE_SMA,NemaPrice,i);
            double sign  = 1;
 
            for (int k=0; k<NemaDepth; k++, sign *= -1)
            {
               if (r<2)
                     work[r][k] = price;
               else  work[r][k] = work[r-1][k]+alpha*(price-work[r-1][k]);
               price = work[r][k];
               nema[i] += price*sign*coeff[k+1];
            }            
         
            //
            //
            //
            //
            //
            
            nemaDa[i] = EMPTY_VALUE;
            nemaDb[i] = EMPTY_VALUE;  
            slope[i]  = slope[i+1];
               if (nema[i]>nema[i+1]) slope[i]  =  1; 
               if (nema[i]<nema[i+1]) slope[i]  = -1;
               upArrow[i]= EMPTY_VALUE;
               dnArrow[i]= EMPTY_VALUE;   
               if (slope[i] != slope[i+1])
               if (slope[i] == 1)
                     upArrow[i] = nema[i+1] - iATR(NULL,0,20,i)/2.0;
               else  dnArrow[i] = nema[i+1] + iATR(NULL,0,20,i)/2.0;
               if (!calculateValue && slope[i]==-1) PlotPoint(i,nemaDa,nemaDb,nema);
      }       
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
   if (slope[limit]==-1) CleanPoint(limit,nemaDa,nemaDb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         nemaDa[i] = EMPTY_VALUE;
         nemaDb[i] = EMPTY_VALUE;
         nema[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NemaPeriod,NemaPrice,NemaDepth,0,y);
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NemaPeriod,NemaPrice,NemaDepth,5,y);
         upArrow[i]= EMPTY_VALUE;
         dnArrow[i]= EMPTY_VALUE; 
         if (slope[i] != slope[i+1])
               if (slope[i] == 1)
                     upArrow[i] = nema[i+1] - iATR(NULL,0,20,i)/2.0;
               else  dnArrow[i] = nema[i+1] + iATR(NULL,0,20,i)/2.0;
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
               nema[i+k] = nema[i] + (nema[i+n]-nema[i])*k/n;
   }
   for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,nemaDa,nemaDb,nema);

   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double factorial(int n)
{
   double a=1; for(int i=1; i<=n; i++) a*=i;
   return(a);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(whichBar,"up");
         if (slope[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," nema slope changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"nema "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}